## mingw-w64-qt6-graphs-6.7.2-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

include(.cmake.conf)
project(QtGraphs
    VERSION "${QT_REPO_MODULE_VERSION}"
    DESCRIPTION "Qt Graphs Libraries"
    HOMEPAGE_URL "https://qt.io/"
    LANGUAGES CXX C
)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals)
find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS Core Quick Gui Widgets QuickTest QuickWidgets Test Quick3D QuickShapesPrivate)

macro(assertTargets)
    foreach(qtTarget IN ITEMS ${ARGN})
        if(NOT TARGET Qt::${qtTarget})
           message(NOTICE "Skipping the build as the condition \"TARGET Qt::${qtTarget}\" is not met.")
           return()
        endif()
    endforeach()
endmacro()

assertTargets(Gui Widgets Quick QuickTest QuickWidgets Test)

qt_build_repo()

=== examples/graphs/3d/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

if(TARGET Qt::Quick)
    if(QT_FEATURE_graphs_3d_bars3d)
        qt_internal_add_example(bars)
    endif()
    if(QT_FEATURE_graphs_3d_scatter3d)
        qt_internal_add_example(axishandling)
        qt_internal_add_example(scatter)
    endif()
    if(QT_FEATURE_graphs_3d_surface3d)
        qt_internal_add_example(surfacegallery)
    endif()
endif()
if(NOT ANDROID AND NOT IOS AND NOT WINRT)
    if(QT_FEATURE_graphs_3d_bars3d AND QT_FEATURE_graphs_3d_scatter3d AND QT_FEATURE_graphs_3d_surface3d)
        qt_internal_add_example(widgetgraphgallery)
    endif()
    if(QT_FEATURE_graphs_3d_scatter3d)
        qt_internal_add_example(widgetvolumetric)
    endif()
endif()

=== tests/manual/directional/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_directional
    GUI
    SOURCES
    main.cpp
    scatterdatamodifier.cpp scatterdatamodifier.h
    )
target_link_libraries(tst_directional PUBLIC
    Qt::Gui
    Qt::Widgets
    Qt::Graphs
    )

=== tests/manual/minimalbars/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_manual_test(tst_minimalbars
    GUI
    SOURCES
        ../../../src/doc/snippets/doc_src_q3dbars_construction.cpp
    )
target_link_libraries(tst_minimalbars PUBLIC
    Qt::Gui
    Qt::Graphs
    )

=== tests/manual/multigraphs/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_multigraphs
    GUI
    SOURCES
        data.cpp data.h
        main.cpp
    )
target_link_libraries(tst_multigraphs PUBLIC
    Qt::Gui
    Qt::Widgets
    Qt::Graphs
    )

set(multigraphs_resource_files
    "australia.png"
    )

qt_internal_add_resource(tst_multigraphs "multigraphs"
    PREFIX
    "/"
    FILES
    ${multigraphs_resource_files}
    )

=== tests/manual/qmlcustominput/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_qmlcustominput
    GUI
    SOURCES
        main.cpp
    )

target_link_libraries(tst_qmlcustominput PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Qml
    Qt::Quick
    Qt::Graphs
)

set(qmlcustominput_resource_files
    "qml/qmlcustominput/Data.qml"
    "qml/qmlcustominput/main.qml"
)

qt6_add_resources(tst_qmlcustominput "qmlcustominput"
    PREFIX
        "/"
    FILES
        ${qmlcustominput_resource_files}
)

=== tests/manual/qmlmultitest/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_manual_test(tst_qmlmultitest
    GUI
    SOURCES
        main.cpp
    )
target_link_libraries(tst_qmlmultitest PUBLIC
    Qt::Gui
    Qt::Graphs
    )

set(qmlmultitest_resource_files
    "qml/qmlmultitest/Data.qml"
    "qml/qmlmultitest/main.qml"
    )

qt_internal_add_resource(tst_qmlmultitest "qmlmultitest"
    PREFIX
    "/"
    FILES
    ${qmlmultitest_resource_files}
    )

=== tests/manual/qmltheme/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_qmltheme
    GUI
    SOURCES
        main.cpp
    )

target_link_libraries(tst_qmltheme PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Qml
    Qt::Quick
    Qt::Graphs
)

set(qmltheme_resource_files
    "qml/qmltheme/main.qml"
    "layer_1.png"
)

qt6_add_resources(tst_qmltheme "qmltheme"
    PREFIX
        "/"
    FILES
        ${qmltheme_resource_files}
)

=== tests/manual/rotations/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_rotations
    GUI
    SOURCES
        main.cpp
        scatterdatamodifier.cpp scatterdatamodifier.h
    )

target_link_libraries(tst_rotations PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Widgets
    Qt::Graphs
)

set(rotations_resource_files
    "mesh/largesphere.mesh"
    "mesh/narrowarrow.mesh"
)

qt6_add_resources(tst_rotations "rotations"
    PREFIX
        "/"
    FILES
        ${rotations_resource_files}
)

=== tests/manual/testbed/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_testbed
    GUI
    SOURCES
        main.cpp
)

target_link_libraries(tst_testbed PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Graphs
)

qt6_add_qml_module(tst_testbed
    URI Testbed
    NO_RESOURCE_TARGET_PATH
    SOURCES
        custombarseries.h custombarseries.cpp
        customlineseries.h customlineseries.cpp
    QML_FILES
        qml/testbed/main.qml
        qml/testbed/StartupView.qml
        qml/testbed/SettingsView.qml
        qml/testbed/CustomCheckBox.qml
        qml/testbed/CustomLabel.qml
        qml/testbed/CustomSelectionBox.qml
        qml/testbed/CustomSlider.qml
        qml/testbed/BarThemes.qml
        qml/testbed/BarSelection.qml
        qml/testbed/LineProperties.qml
        qml/testbed/AxisGridSetup.qml
        qml/testbed/Callout.qml
        qml/testbed/ScatterProperties.qml
        qml/testbed/CppBarSeries.qml
        qml/testbed/CppLineSeries.qml
    RESOURCES
        qml/testbed/images/arrow_icon.png
        qml/testbed/images/icon_settings.png
        qml/testbed/images/happy_box.png
        qml/testbed/images/Sevillana-Regular.ttf
)

=== tests/manual/volumetrictest/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

set(CMAKE_INCLUDE_CURRENT_DIR ON)

qt_internal_add_manual_test(tst_volumetrictest
    GUI
    SOURCES
        main.cpp
        volumetrictest.cpp volumetrictest.h
    )

target_link_libraries(tst_volumetrictest PUBLIC
    Qt::Gui
    Qt::Widgets
    Qt::Graphs
    )

set_source_files_properties("cubeFilledFlat.mesh"
    PROPERTIES QT_RESOURCE_ALIAS "mesh"
    )
set(volumetrictest_resource_files
    "cubeFilledFlat.mesh"
    "logo.png"
    "logo_no_padding.png"
    )

qt_internal_add_resource(tst_volumetrictest "volumetrictest"
    PREFIX
    "/"
    FILES
    ${volumetrictest_resource_files}
    )

=== examples/graphs/3d/axishandling/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(axishandling LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(NOT DEFINED INSTALL_EXAMPLESDIR)
  set(INSTALL_EXAMPLESDIR "examples")
endif()

set(INSTALL_EXAMPLEDIR "${INSTALL_EXAMPLESDIR}")

find_package(Qt6 COMPONENTS Core)
find_package(Qt6 COMPONENTS Gui)
find_package(Qt6 COMPONENTS Quick)
find_package(Qt6 COMPONENTS Quick3D)
find_package(Qt6 COMPONENTS Graphs)

qt_add_executable(axishandling
    main.cpp
)
set_target_properties(axishandling PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)
target_link_libraries(axishandling PUBLIC
    Qt::Core
    Qt::Gui
    Qt::Quick
    Qt::Quick3D
    Qt::Graphs
)

qt6_add_qml_module(axishandling
    URI AxisHandling
    NO_RESOURCE_TARGET_PATH
    SOURCES
        customformatter.cpp customformatter.h
    QML_FILES
        qml/axishandling/main.qml
        qml/axishandling/Data.qml
        qml/axishandling/AxisDragging.qml
        qml/axishandling/AxisFormatting.qml
    RESOURCES
        qml/axishandling/cube.mesh
        qml/axishandling/cubetexture.png
)

install(TARGETS axishandling
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-graphs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.7.2
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt Data Visualization module provides multiple graph types to visualize data in 3D space (mingw-w64)'
arch=(any)
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgraphs.git"
msys2_references=(
  'archlinux: qt6-graphs'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:BSD-3-Clause WITH Qt-GPL-exception-1.0 AND GPL-3.0-only AND GFDL-1.3-no-invariants-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('d8813a266e4a56367af6c3206670c908f64794e6806402142b2e028046128600')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-graphs() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
           "${MINGW_PACKAGE_PREFIX}-qt6-quick3d")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs ${pkgdir}/.${MINGW_PREFIX} ${srcdir}/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-graphs-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf ${srcdir}/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
